#include <iostream>

using namespace std;

int main()
{
    int n,q;
    long s,b;
    cin>>n>>q;
    long d[n];
    int p[n];
    long k[q];
    for(int i=0;i<n;i++){
        cin>>d[i]>>p[i];
    }
    for(int j=0;j<q;j++){
        cin>>k[j];
    }
    int m;
    for(int j=0;j<q;j++){
        s=0;
        b=0;
        m=0;
        for(long l=1;l<=k[j];l++){
            if(m<n&&d[m]==l){
                s=s+p[m];
                m++;
            }
            if(s>0){
                s--;
                b++;
            }
        }
        cout<<b<<endl;
    }
}